"use strict";
(function(){
    var chart = {
        xyz: "hello"
    };
    var classes = {};
    /* Chart Rendering Function*/
    chart.renderChart = function(chartopts,hi_container) {

        var _chart = {};
        if (classes[chartopts.type]) {

            _chart = $.extend(true, _chart, classes[chartopts.type]);

            /* When we extend _chart from its corresponding class object, it will have the default 'options' defined in the class.
             The below statement is to override the default options with those given by user */

            _chart.options = $.extend(true, _chart.options, chartopts);
            //_chart.parent = this;
			if (typeof _chart.validate === 'function') {
                var a = _chart.validate();
				if(a === 0){
				 return;
				}
            }
            if (typeof _chart.processdata === 'function') {
                _chart.processdata();
            }
            if (typeof _chart.draw === 'function') {
                _chart.draw(hi_container);
            }
        }

        return _chart;
    };

    window.chart = chart;


    /* Defining various Charts */

    classes.Chart = {
        options: {},
        processdata: null,
        draw: null,
		valdate:null,
        transform: null
    };
    classes.Charts = $.extend(true, {}, classes.Chart);
	classes.Charts.validate = function(){
	   var _options = this.options;

	   var type = ["HorizontalStackedBar"];
		if(((_options.data.Dimension.length < 2) || _options.data.Measure.length < 1) && type.indexOf(_options.type) >= 0){
		   d3.select("#chart").append("div").attr("class","HI-Core-Error alert alert-danger")
			.text("There is some problem in the data or the configuration of the chart. Please check.");
			$.notify({message: "There is some problem in the data or the configuration of the chart. Please check.", icon: "fa fa-exclamation-triangle"}, {type: "danger"});
			return 0;
		}
	   return 1;
	 };
    classes.Charts.typemap = {
        PieChart: 'Pie',
        DonutChart: 'donut',
        BarChart: 'bar',
        LineChart: 'line',
        ScatterChart: 'scatter',
        AreaChart: 'area',
        SplineChart: 'spline',
        AreaSplineChart: 'area-spline',
        StepChart: 'step',
        AreaStepChart: 'area-step',
        GaugeChart: 'gauge',
		HIGroupedBar: 'bar',
		HorizontalStackedBar: 'bar',
		PercentageStackedBar: 'bar'
    };
    classes.Charts.transformable = ["BarChart", "LineChart", "AreaChart", "ScatterChart", "AreaStepChart", "SplineChart", "StepChart", "AreaSplineChart", "GaugeChart","HIGroupedBar"];
    classes.Charts.options = {

        type: 'BarChart',
		padding: {},
        data: {

            jsondata: {},
            categorykey: [],
            valuekeys: [],
            groupkeys: [[]],
            axes: {},
            types: {},
            selection: {},
			onclick: function(){},
			color: function(color){return color;},
			colors: {}
        },
		
		subchart: {
            show: false
        },
		
        placeholder: 'chart',

        BarChart: {zerobased: true},
        //title: 'Chart Title',
        size: {
            height: null,
            width: null
        },

        labels: true,

        empty: {
            abort: false
        },

        tooltip: {
            show: true,
			 format: {
    
            value: function (value, ratio, id) {
                var format = id === 'data1' ? d3.format('.4s') : d3.format('.4s');
                return format(value);
            }},
            grouped: false
        },

        legend: {
            show: true
        },
        color: {
            //pattern: [  '#01cce3' , '#5366d0' , '#ff1d45' , '#ffb200' , '#01c993' , '#5dffda' , '#ff3c80' , '#677077' , '#d3eeef' , '#9068be' , '#daad86' , '#3fb0ac' , '#fae596' , '#7082d9' , '#c43235' , '#fccdd3' , '#bbc4ef' , '#cdd422' , '#b5a397' , '#f89400']
            // pattern: [ '#edc54a','#28d7b3','#fa6c5b','#735ea4','#27bfd7','#e377c2','#7f7f7f','#8c564b']
            pattern: [ '#81b8ec','#434348','#90ed7d','#f7a35c','#9498ec','#f15c80','#e7d764','#2b908f','#f45b5b','#91e8e1','#7cb5ec']
        },
		gauge: {
			label: {
				format: function(value, ratio) {
					var formatComma = d3.format(".4s");
					return (formatComma(value));
				},
				show: true
			},
			min: 1000,
			max: 10000
		},
        axis: {
            rotated: false,
            x: {
                localtime: false,
                padding: {top: 20, bottom: 20},//Set padding for x axis
                //Set label for axis.
                label: {
                    text: '',
                    position: 'inner-right'
                },
                type: '',
                tick: {  
					culling: {     
						max: 5 // the number of tick texts will be adjusted to less than this value
					},
                    rotate: 45, //Rotate x axis tick text. Default is false.
                    fit: true, //Fit x axis tick. Default is true.
					multiline: true 
                }   

            },
            y: {
                show: true, //Show or hides y axis. Default is true.
                inverted: false,
                label: {
                    padding: {},
                    text: '',
                    position: ''
                },
				tick: {
						format: d3.format(',s')
				}
            },
            y2: {
                show: false, //Show or hides y2 axis. Default is true.
                
				tick: {
						format: d3.format(',s')
				}
            }
        },

        point: {
            show: true,			//Whether to show each point in line. Default is true
            r: 2.5,				//The radius size of each point. Default is 2.5
            select: {r: 10},		//The radius size of each point on selected.
            focus: {
                expand: {r: 10}	//Whether to expand each point on focus. Default is true
            }
        },

        regions: [],

        zoom: {
            enabled: false,
            rescale: true
        },

        

        interaction: {
            enabled: true
        },
        grid: {

            focus: {
                show: false
            },
            x: {
                show: false
            },
            y: {
                focus: {
                    show: false
                },
                show: true
            }
        },
		onresized: function() {
	        this.selectChart.style('max-height', 'none')
	    },
		onrendered: function () { }
    };

    classes.Charts.draw = function(hi_container) {

        var _options = this.options;
		function original2StackFormatData(optionsData){
			var textColumnName = optionsData.Dimension;
			var numericColumnName = optionsData.Measure;
			var data = optionsData.jsondata;
			var manager_names = [];
			var unique_names = [];
			var final_obj = {};
			var final_array = [];
			var job_titles = [];
			var unique_jobtitles = [];
			var textColumnNameLength = textColumnName.length - 1;
			var textColumnNameLengthMinusOne = textColumnName.length - 2;
			var lastMeasureValue = numericColumnName.length - 1;

			for(var i=0;i<data.length;i++){
			  manager_names.push(data[i][textColumnName[textColumnNameLengthMinusOne]]);
			}

			for(var i=0;i<data.length;i++){
			  job_titles.push(data[i][textColumnName[textColumnNameLength]]);
			}

			$.each(manager_names, function(i, el){
			if($.inArray(el, unique_names) === -1) unique_names.push(el);
			});

			$.each(job_titles, function(i, el){
			if($.inArray(el, unique_jobtitles) === -1) unique_jobtitles.push(el);
			});

			for(var i=0;i<unique_names.length;i++){
				 final_obj.dimension = unique_names[i];
				 final_array.push(final_obj)
				 final_obj = {};
			}

			for(var i=0;i<data.length;i++){
			   var Category = data[i][textColumnName[textColumnNameLength]];
			   var final_arr_index = unique_names.indexOf(data[i][textColumnName[textColumnNameLengthMinusOne]]);
			   final_array[final_arr_index][Category] = data[i][numericColumnName[lastMeasureValue]];
			}
			return [final_array,unique_jobtitles,numericColumnName,textColumnName];
		}
		function stackFormatData2PercentageStackFormatData(stackFormatData){
			var stackFormatDataLength = stackFormatData.length;
			var rowWiseTotalArray = new Array();
			for(var stackFormatDataIter = 0; stackFormatDataIter < stackFormatDataLength; stackFormatDataIter++){
				var tempTotal = 0;
				var stackKeys = Object.keys(stackFormatData[stackFormatDataIter]);
				for(var stackKeysIter = 0; stackKeysIter < stackKeys.length; stackKeysIter++){
					if(stackKeys[stackKeysIter] !== 'dimension'){
						tempTotal = tempTotal + stackFormatData[stackFormatDataIter][stackKeys[stackKeysIter]];
					}
				}
				rowWiseTotalArray.push(tempTotal);
			}
			for(var stackFormatDataIter = 0; stackFormatDataIter < stackFormatDataLength; stackFormatDataIter++){
//				var tempRow = stackFormatData[stackFormatDataIter];
				var stackKeys = Object.keys(stackFormatData[stackFormatDataIter]);
				for(var stackKeysIter = 0; stackKeysIter < stackKeys.length; stackKeysIter++){
					if(stackKeys[stackKeysIter] !== 'dimension'){
						stackFormatData[stackFormatDataIter][stackKeys[stackKeysIter]] = (stackFormatData[stackFormatDataIter][stackKeys[stackKeysIter]]/rowWiseTotalArray[stackFormatDataIter])*100;
					}
				}
			}
			return stackFormatData;
		}
        var types = {};
		var categories = [];
		var keys;
	if (_options.type === "HIGroupedBar"){
		var data = _options.data.jsondata;
		var val1 = [], val2 = [],valObj = {};
		data.forEach(function(item){
			var temp = Object.keys(item);
			var val= item[temp[1]];
			if(!valObj.hasOwnProperty(val)){
				valObj[val] = [];
				valObj[val].push(item[temp[2]]);
			}else {
				valObj[val].push(item[temp[2]]);
			}
		});
		_options.data.jsondata = valObj;
		_options.data.categorykey = "";
		_options.data.valuekeys = "";
		keys = "";

	}
	else if(_options.type === "HorizontalStackedBar"){
		var data = _options.data;
		var stackFormatDataArray = original2StackFormatData(data);
		_options.data.jsondata = stackFormatDataArray[0];
		_options.data.valuekeys = stackFormatDataArray[1];
		keys={x : 'dimension',value:stackFormatDataArray[1]};
		_options.data.groupkeys = [stackFormatDataArray[1]];
		_options.axis.rotated= true;
		_options.axis.y.label.text = stackFormatDataArray[2][stackFormatDataArray[2].length-1];
		_options.axis.x.label.text = '';
	}else if(_options.type === 'PercentageStackedBar'){
		var data = _options.data;
		var stackFormatDataArray = original2StackFormatData(data);
		var percentageStackData = stackFormatData2PercentageStackFormatData(stackFormatDataArray[0]);
		//_options.data.jsondata = stackFormatDataArray[0];
		_options.data.jsondata = percentageStackData;

		_options.data.valuekeys = stackFormatDataArray[1];
		keys={x : 'dimension',value:stackFormatDataArray[1]};
		_options.data.groupkeys = [stackFormatDataArray[1]];
		_options.axis.y.label.text = stackFormatDataArray[2][stackFormatDataArray[2].length-1];
		_options.axis.y.max = 100;
		_options.axis.y.padding =5;
		_options.axis.x.label.text = '';
		_options.tooltip.format={value: function (value, ratio, id, index) { var format = d3.format(",.2f"); return format(value)+'%'; }}

	}else{
		keys = {
			x: _options.data.categorykey,
			value: _options.data.valuekeys

		}
	}
	var customFunction = function(){};
	var customFunctionBarChart = function (that) {
			var columns = _options.data.Measure;
			var dimensions = _options.data.Dimensions;
			var svgDefs = that.svg.select("defs");
			if(!svgDefs.empty()){
				if(_options.type === "HIGroupedBar" ){
					var barsData = Object.keys(_options.data.jsondata);
					that.svg.select('.c3-chart-bars').selectAll('.c3-chart-bar').each(function(d){
						var columnClass = d3.select(this).select('.c3-shapes').attr('class').split(' ').join('-');
							var circleParentBars = d3.select(this).select('.c3-shapes').selectAll('path');
							if(!circleParentBars.empty()){
								var hexColor = circleParentBars.style('fill');
								var darkercolor = d3.rgb(hexColor).darker(1.5).toString();
								var lightercolor = d3.rgb(hexColor).brighter(0.2).toString();
								var linearGradient = svgDefs.append("defs")
								.append("linearGradient")
								.attr("id", "linear-gradient-"+columnClass+"-"+_options.placeholder.id)
								.attr("x1", "0%")
								.attr("y1", "100%")
								.attr("x2", "30%")
								.attr("y2", "0%");

							linearGradient.append("stop")
								.attr("offset", "20%")
								.attr("stop-color", darkercolor).attr("spreadMethod", "pad");
							linearGradient.append("stop")
								.attr("offset", "100%")
								.attr("stop-color", lightercolor).attr("spreadMethod", "pad");
							linearGradient.append("stop")
								.attr("offset", "100%")
								.attr("stop-color", hexColor);
								circleParentBars.style("fill", "url(#linear-gradient-"+columnClass+"-"+_options.placeholder.id+")")
								//.style("filter", "url(#drop-shadow"+"-"+_options.placeholder.id+")");
							}
					})
				}
				else if(_options.type === "HorizontalStackedBar" ){
					var barsData = Object.keys(_options.data.jsondata[0]);
					for(var columnsIter = 0; columnsIter < barsData.length; columnsIter++){
							var columnClassName = barsData[columnsIter];
							 columnClass = columnClassName.split(' ').join('-');
							//var columnClass = columnAlias.split('_').join('-')
							var circleParentBars = that.svg.select('.c3-chart-bars').select('.c3-target-'+columnClass).select('.c3-shapes-'+columnClass).selectAll('path');
							if(!circleParentBars.empty()){
								var hexColor = circleParentBars.style('fill');
								var darkercolor = d3.rgb(hexColor).darker(1.5).toString();
								var lightercolor = d3.rgb(hexColor).brighter(0.2).toString();
								var linearGradient = svgDefs.append("defs")
								.append("linearGradient")
								.attr("id", "linear-gradient-"+columnClass+"-"+_options.placeholder.id)
								.attr("x1", "0%")
								.attr("y1", "100%")
								.attr("x2", "0%")
								.attr("y2", "30%");

							linearGradient.append("stop")
								.attr("offset", "30%")
								.attr("stop-color", darkercolor).attr("spreadMethod", "pad");
							linearGradient.append("stop")
								.attr("offset", "100%")
								.attr("stop-color", lightercolor).attr("spreadMethod", "pad");
							linearGradient.append("stop")
								.attr("offset", "100%")
								.attr("stop-color", hexColor);
								circleParentBars.style("fill", "url(#linear-gradient-"+columnClass+"-"+_options.placeholder.id+")")
								.style("filter", function(d){
								if(barsData.length === columnsIter){
									return "url(#drop-shadow-bar"+"-"+_options.placeholder.id+")";
								}
								});
							}
					}
				}
				else if(_options.type === "PercentageStackedBar" ){
					var barsData = _options.data.groupkeys[0];
					that.svg.select('.c3-chart-bars').selectAll('.c3-chart-bar').each(function(d){

							 var columnClass = d3.select(this).select('.c3-shapes').attr('class').split(' ').join('-');
							//var columnClass = columnAlias.split('_').join('-')
							var circleParentBars = d3.select(this).select('.c3-shapes').selectAll('path');
							if(!circleParentBars.empty()){
								var hexColor = circleParentBars.style('fill');
								var darkercolor = d3.rgb(hexColor).darker(1.5).toString();
								var lightercolor = d3.rgb(hexColor).brighter(0.2).toString();
								var linearGradient = svgDefs.append("defs")
								.append("linearGradient")
								.attr("id", "linear-gradient-"+columnClass+"-"+_options.placeholder.id)
								.attr("x1", "100%")
								.attr("y1", "0%")
								.attr("x2", "30%")
								.attr("y2", "0%");

							linearGradient.append("stop")
								.attr("offset", "30%")
								.attr("stop-color", darkercolor).attr("spreadMethod", "pad");
							linearGradient.append("stop")
								.attr("offset", "100%")
								.attr("stop-color", lightercolor).attr("spreadMethod", "pad");
							linearGradient.append("stop")
								.attr("offset", "100%")
								.attr("stop-color", hexColor);
								circleParentBars.style("fill", "url(#linear-gradient-"+columnClass+"-"+_options.placeholder.id+")");
							}
					})
				}
				else{
					that.svg.select('.c3-chart-bars').selectAll('.c3-chart-bar').each(function(d){
						var columnClass = d3.select(this).select('.c3-shapes').attr('class').split(' ').join('-');
						var circleParentBars = d3.select(this).select('.c3-shapes').selectAll('path');
						if(!circleParentBars.empty()){
							var hexColor = circleParentBars.style('fill');
							var darkercolor = d3.rgb(hexColor).darker(1.5).toString();
							var lightercolor = d3.rgb(hexColor).brighter(0.2).toString();
							var linearGradient = svgDefs.append("defs")
							.append("linearGradient")
							.attr("id", "linear-gradient-bar-"+columnClass+"-"+_options.placeholder.id)
							.attr("x1", "100%")
							.attr("y1", "0%")
							.attr("x2", "30%")
							.attr("y2", "0%");

						linearGradient.append("stop")
							.attr("offset", "20%")
							.attr("stop-color", darkercolor).attr("spreadMethod", "pad");
						linearGradient.append("stop")
							.attr("offset", "100%")
							.attr("stop-color", lightercolor).attr("spreadMethod", "pad");
						linearGradient.append("stop")
							.attr("offset", "100%")
							.attr("stop-color", hexColor);
							circleParentBars.style("fill", "url(#linear-gradient-bar-"+columnClass+"-"+_options.placeholder.id+")")
							.style("filter", "url(#drop-shadow-bar"+"-"+_options.placeholder.id+")");
						}
				});
				}
				var dropShadowFilterLine = svgDefs.append('svg:filter')
					  .attr('width',"200%")
					  .attr('height',"200%")
					  .attr('id', 'drop-shadow-bar'+'-'+_options.placeholder.id);

					dropShadowFilterLine.append('svg:feOffset')
					  .attr('in', 'SourceAlpha')
					  .attr('dx', 4)
					  .attr('dy', 0)
					  .attr('result', 'the-shadow');

					dropShadowFilterLine.append('svg:feGaussianBlur')
					  .attr('in', 'the-shadow')
					  .attr('stdDeviation',5)
					  .attr('result', 'blur-out');

					dropShadowFilterLine.append('svg:feBlend')
					  .attr('in', 'SourceGraphic')
					  .attr('in2', 'blur-out')
					  .attr('mode', 'normal');
			}
		}
	var customFunctionOtherCharts = function (that) {

			var columns = _options.data.Measure;
			var svgDefs = that.svg.select("defs");
			if(!svgDefs.empty()){
				that.svg.select('.c3-chart-lines').selectAll('.c3-chart-line').each(function(d){
						var columnClass = d3.select(this).select('.c3-areas').attr('class').split(" ").join('-');
						var circleParent = d3.select(this).select('.c3-lines').select('path');
						var circle = d3.select(this).select('.c3-circles').selectAll('circle');
						var circleParentArea = d3.select(this).select('.c3-areas').select('path');

						if(!circleParentArea.empty()){
							var linearGradientotherCharts = svgDefs.append("defs")
							.append("linearGradient")
							.attr("id", "linear-gradient-"+columnClass+"-"+_options.placeholder.id)
							.attr("x1", "0%")
							.attr("y1", "100%")
							.attr("x2", "0%")
							.attr("y2", "0%");
						linearGradientotherCharts.append("stop")
							.attr("offset", "0%")
							.attr("stop-color", '#fff').attr("spreadMethod", "pad");
						linearGradientotherCharts.append("stop")
							.attr("offset", "70%")
							.attr("stop-opacity",10)
							.attr("stop-color",circleParentArea.style('fill'));
							circleParentArea.style("stroke","url(#linear-gradient-"+columnClass+"-"+_options.placeholder.id+")");
							circleParentArea.style("fill","url(#linear-gradient-"+columnClass+"-"+_options.placeholder.id+")");
						}
						if(!circleParent.empty() && !circle.empty()){
							circle.style('fill','#fff').style('stroke',circleParent.style('stroke')).style('stroke-width',2)
							//.style("filter", "url(#drop-shadow-line"+"-"+_options.placeholder.id+")");;
							circleParent.style('stroke-width','4px');
							circleParent.style("filter", "url(#drop-shadow-line"+"-"+_options.placeholder.id+")");
						}
				});
				var dropShadowFilterLine = svgDefs.append('svg:filter')
					  .attr('width',"200%")
					  .attr('height',"200%")
					  .attr('id', 'drop-shadow-line'+'-'+_options.placeholder.id);

					dropShadowFilterLine.append('svg:feOffset')
					  .attr('in', 'SourceGraphic')
					  .attr('dx', 4)
					  .attr('dy', 0)
					  .attr('result', 'the-shadow');

					dropShadowFilterLine.append('svg:feGaussianBlur')
					  .attr('in', 'the-shadow')
					  .attr('stdDeviation',5)
					  .attr('result', 'blur-out');

					dropShadowFilterLine.append('svg:feBlend')
					  .attr('in', 'SourceGraphic')
					  .attr('in2', 'blur-out')
					  .attr('mode', 'normal');
			}
		}
        for(var key in _options.data.types) {
            types[key] = _options.data.types[key];
			if(_options.data.types[key] === 'line' || _options.data.types[key] === 'spline' || _options.data.types[key] === 'area' || _options.data.types[key] === 'step'||_options.data.types[key] === 'area-spline'||_options.data.types[key] === 'area-step'){
				_options.point.r=4;
			}
        }

	if(_options.type === 'LineChart'||_options.type === 'AreaChart' || _options.type === 'SplineChart' || _options.type === 'AreaSplineChart' || _options.type === 'StepChart' || _options.type === 'AreaStepChart'){
		_options.point.r=4;
		//customFunction = customFunctionOtherCharts;
	}

		var c3chart = c3.generate({
            bindto: _options.placeholder,
            data: {
                json: _options.data.jsondata,
                keys: keys,
                type:this.typemap[_options.type],
                groups: _options.data.groupkeys,
                axes: _options.data.axes,
                labels: _options.data.labels,
                types: _options.data.types,
                selection: _options.data.selection,
                onclick: _options.data.onclick,
                onmouseover: _options.data.onmouseover,
                onmouseout: _options.data.onmouseout,
                onselected: _options.data.onselected,
                onunselected: _options.data.onunselected,
				color: _options.data.color,
				colors: _options.data.colors
            },

            labels: _options.labels,
            legend: _options.legend,
            interaction: _options.interaction,
            size: _options.size,
            regions: _options.regions,
            empty: _options.empty,
            padding: _options.padding,
            tooltip: _options.tooltip,
            color: _options.color,
            sort: _options.sort,
            ondragstart: _options.ondragstart,
            ondragend: _options.ondragend,
            axis: _options.axis,
            point: _options.point,
            subchart: _options.subchart,
            zoom: _options.zoom,
            grid: _options.grid,
			onresize: _options.onresize,
			onresized: _options.onresized,
			onrendered: function(){
		//		customFunctionBarChart(this);
		//		customFunctionOtherCharts(this);
	//			customFunction(this);
				_options.onrendered(this);
			}
        });

		hi_container.set('c3Chart',c3chart);
        this.c3chart = c3chart;
    };

    classes.Charts.flow = function(newdata) {
        var _options = this.options;
        this.c3chart.flow({
            json: newdata,
            keys: {
                x: _options.data.categorykey,
                value: _options.data.valuekeys
            },
            length: 3,
            duration: 1500
        });
    };

    classes.Charts.load = function(newdata) {
        var _options = this.options;
        this.c3chart.load({
            json: newdata,
            keys: {
                x: _options.data.categorykey,
                value: _options.data.valuekeys
            },
            duration: 1500
        });
    };
    classes.Charts.transform = function(transformTo){
        var _options = $.extend(true, {}, this.options);
        var newchart = {};
        if ($.inArray(transformTo, this.transformable) > -1) {
            this.c3chart.transform(this.typemap[transformTo]);
            newchart = this;
        }
        else if($.inArray(transformTo, classes.C3ArrayCharts.transformable) > -1){
            _options.type = transformTo;
            _options.data.serieskey = _options.data.categorykey;
            _options.data.valuekey = _options.data.valuekeys[0];
            newchart = chart.renderChart(_options);
        }
        else{
        }
        return newchart;

    };


    classes.C3ArrayCharts = $.extend(true, {}, classes.Chart);
    classes.C3ArrayCharts.typemap = {
        AreaChart: 'area',
        BarChart: 'bar',
        LineChart: 'line',
        ScatterChart: 'scatter',
        SplineChart: 'spline',
        StepChart: 'step',
        AreaSplineChart: 'area-spline',
        AreaStepChart: 'area-step',
        PieChart: 'pie',
        DonutChart: 'donut',
        BubbleChart: 'bubble'
    };

    classes.C3ArrayCharts.transformable = ["PieChart", "DonutChart","BubbleChart"];

    classes.C3ArrayCharts.options = {
        data: {
               jsondata: {},
			         pairs: {},
               serieskey: '',
			         serieskeys: [],
               valuekey: '',
			         onclick: function(){},
               onmouseover: function(){},
               onmouseout: function(){},
               onselected: function(){},
               onunselected: function(){},
               colors:{},
		},
        placeholder: 'chart',


		donut: {
			title: " "
		},
		pie:{
			label:{}
		},
		tooltip: {
            show: true
        },
        size: {
            height: null,
            width: null
        },
        order: 'asc',
        padding: {
            top: 20,
            right: 50,
            bottom: 20,
            left: 50
        },
        empty: {
            abort: false,
            label: {
                text: 'hoge'
            }
        },

        legend: {
            show: true
        },


        selection: {
            enabled: true,
            grouped: false,
            multiple: true
        },
        color: {
            //pattern:[  '#01cce3' , '#5366d0' , '#ff1d45' , '#ffb200' , '#01c993' , '#5dffda' , '#ff3c80' , '#677077' , '#d3eeef' , '#9068be' , '#daad86' , '#3fb0ac' , '#fae596' , '#7082d9' , '#c43235' , '#fccdd3' , '#bbc4ef' , '#cdd422' , '#b5a397' , '#f89400']
			// pattern: [ '#edc54a','#28d7b3','#fa6c5b','#735ea4','#27bfd7','#e377c2','#7f7f7f','#8c564b']
			 pattern: [ '#81b8ec','#434348','#90ed7d','#f7a35c','#9498ec','#f15c80','#e7d764','#2b908f','#f45b5b','#91e8e1','#7cb5ec']
        },
		onclick: function(){},
		onresized: function fixMaxHeight () {
		    this.selectChart.style('max-height', 'none')
	    },
		onrendered: function () {},
		oninit: function () {}
    };

    classes.C3ArrayCharts.processdata = function () {
        var _options = this.options;
        var _ArrayData = [];
        if (this.typemap[_options.type] == "bubble"){
          for (var _i = 0; _i < _options.data.jsondata.length; _i++) {
              _ArrayData[_i] = [];
              _ArrayData[_i].push(_options.data.jsondata[_i][_options.data.serieskeys[0]]);
              _ArrayData[_i].push(_options.data.jsondata[_i][_options.data.serieskeys[1]]);
              _ArrayData[_i].push(_options.data.jsondata[_i][_options.data.valuekey]);
          }
        }else {
          for (var _i = 0; _i < _options.data.jsondata.length; _i++) {
              _ArrayData[_i] = [];
              _ArrayData[_i].push(_options.data.jsondata[_i][_options.data.serieskey]);
              _ArrayData[_i].push(_options.data.jsondata[_i][_options.data.valuekey[0]]);
          }
        }
        this.ArrayData = _ArrayData;
    };

    classes.C3ArrayCharts.draw = function(hi_container) {
        var _options = this.options;
		var dimension = _options.data.Dimension[_options.data.Dimension.length-1];
		var customOnrenderedFunction = function(that){
			var svgDefs = that.svg.select("defs");
		if(_options.type === 'PieChart'){
			that.svg.select('.c3-chart-arcs').selectAll('.c3-chart-arc').each(function(d){
				var columnClass = d3.select(this).select(".c3-shapes").attr('class').split(' ').join('-');
				var circleParent = d3.select(this).select(".c3-shapes").select("path");
				circleParent.style('stroke',circleParent.style('fill'));
			})
			var rect = d3.select(".c3-event-rects-single").select('rect');
			//var circleParent = d3.select('.c3-chart-bars').select('.c3-target-Office').select('.c3-bars-Office').select('path');
			var dropShadowFilter = svgDefs.append('svg:filter')
					  .attr('width',"200%")
					  .attr('height',"200%")
					  .attr('id', 'drop-shadow-'+_options.placeholder.id);
					dropShadowFilter.append('svg:feOffset')
					  .attr('in', 'SourceAlpha')
					  .attr('dx', 4)
					  .attr('dy', 2)
					  .attr('result', 'the-shadow');
					dropShadowFilter.append('svg:feColorMatrix')
					  .attr('in', 'the-shadow')
					  .attr('type', 'hueRotate')
					  .attr('values', '0.2 0 0 0 0 0 0.2 0 0 0 0 0 0.2 0 0 0 0 0 1 0')
					  .attr('result', 'color-out');
					dropShadowFilter.append('svg:feGaussianBlur')
					  .attr('in', 'color-out')
					  .attr('stdDeviation',6)
					  .attr('result', 'blur-out');
					dropShadowFilter.append('svg:feBlend')
					  .attr('in', 'SourceGraphic')
					  .attr('in2', 'blur-out')
					  .attr('mode', 'normal');
			setTimeout(function(){
				d3.select(_options.placeholder).select(".c3-event-rects-single").select('circle').remove();
				d3.select(_options.placeholder).select(".c3-event-rects-single").append('circle').attr("class","c3-event-rects c3-event-rects-single")
				.attr('cx',d3.transform(d3.select(_options.placeholder).select('.c3-chart-arcs').attr('transform')).translate[0]).attr('cy',d3.transform(d3.select(_options.placeholder).select('.c3-chart-arcs').attr('transform')).translate[1]).attr('r',function(){

				var width = d3.select(_options.placeholder).select('.c3-chart-arcs').node().getBBox().width;
					if(width != 0){
					return (width/2)-4;
					}
					else return 0;
					})
				.style("filter", "url(#drop-shadow-"+_options.placeholder.id+")").style('fill-opacity', 5).style('fill', '#ffffff');
				//circleParent.style('stroke',circleParent.style('fill'));
			}, 0);
		}
		if(_options.type === 'DonutChart'){
			var dataLength = _options.data.jsondata.length;
			var columnIterator = 0;
			that.svg.select('.c3-chart-arcs').selectAll('.c3-chart-arc').each(function(d){
					var columnClass =  d3.select(this).select(".c3-shapes").attr("class").split(' ').join('-');
					var circleParent =  d3.select(this).select(".c3-shapes").select("path")
					var sw = 10/dataLength;
						circleParent.style('stroke-width',sw);
					circleParent.style('stroke','#fff');
					//	circleParent.style("fill","url(#linear-gradient-"+columnClass+"-"+_options.placeholder.id+")");

				})
		}
		};
        var c3chart = c3.generate({
            bindto: _options.placeholder,
            data: {
                columns: this.ArrayData,
                pairs: this.ArrayData,
                type: this.typemap[_options.type],
				colors: _options.data.colors,
				onclick: _options.data.onclick,
                onmouseover: _options.data.onmouseover,
                onmouseout: _options.data.onmouseout,
                onselected: _options.data.onselected,
                onunselected: _options.data.onunselected,
            },
            legend: _options.legend,
            size: _options.size,
            padding: _options.padding,
            color: _options.color,
			donut: _options.donut,
			pie: _options.pie,
			tooltip: _options.tooltip,
			onresized: _options.onresized,
			oninit: _options.oninit,
			onrendered: function(){
				_options.onrendered(this);
				customOnrenderedFunction(this);
			}
        });
		hi_container.set('c3Chart',c3chart);
        this.c3chart = c3chart;
    };

    classes.C3ArrayCharts.transform = function(transformTo) {
        var _options = $.extend(true, {}, this.options);
        var newchart = {};
        if ($.inArray(transformTo, this.transformable) > -1) {
            this.c3chart.transform(this.typemap[transformTo]);
            newchart = this;
        }
        else if($.inArray(transformTo, classes.Charts.transformable) > -1){
            _options.type = transformTo;
            _options.data.categorykey = _options.data.serieskey;
            _options.data.valuekeys = [_options.data.valuekey];
            newchart = chart.renderChart(_options);
        }
        else {
        }
        return newchart;
    };

    classes.C3ArrayCharts.flow = function(newdata) {
        var _options = this.options;
        this.c3chart.flow({
            json: newdata,
            keys: {
                x: _options.data.categorykey,
                value: _options.data.valuekeys
            },
            length: 3,
            duration: 1500
        });
    };

    /* ----------------Defining PieChart--------------------------*/
    classes.PieChart = $.extend(true, {}, classes.C3ArrayCharts);

    /* ----------------Defining C3DonnutChart-----------------------*/
    classes.DonutChart = $.extend(true, {}, classes.C3ArrayCharts);

  /* ----------------Defining C3BubbleChart-----------------------*/
    classes.BubbleChart = $.extend(true, {}, classes.C3ArrayCharts);

    /* ----------------Defining BarChart--------------------------*/
    classes.BarChart = $.extend(true, {}, classes.Charts);

    /* ----------------Defining LineChart-------------------------*/
    classes.LineChart = $.extend(true, {}, classes.Charts);

    /* ----------------Defining AreaChart-------------------------*/
    classes.AreaChart = $.extend(true, {}, classes.Charts);

    /* ----------------Defining SplineChart-----------------------*/
    classes.SplineChart = $.extend(true, {}, classes.Charts);

    /* ----------------Defining StepChart-------------------------*/
    classes.StepChart = $.extend(true, {}, classes.Charts);

    /* ----------------Defining AreaSplineChart-------------------*/
    classes.AreaSplineChart = $.extend(true, {}, classes.Charts);

    /* ----------------Defining AreaStepChart---------------------*/
    classes.AreaStepChart = $.extend(true, {}, classes.Charts);

    /* ----------------Defining ScatterChart-----------------------*/
    classes.ScatterChart = $.extend(true, {}, classes.Charts);

    /* ----------------Defining HIGroupedBar-----------------------*/
    classes.HIGroupedBar= $.extend(true, {}, classes.Charts);

    classes.HorizontalStackedBar= $.extend(true, {}, classes.Charts);

    classes.PercentageStackedBar= $.extend(true, {}, classes.Charts);

    /*-----------------Defining GaugeChartChart----------------------*/
    classes.GaugeChart = $.extend(true, {}, classes.Charts);

})();
